# $Id: bos_category.rb,v 1.7 2006/10/24 05:39:03 nisyu Exp $

class BosCategory
	include BOS::PropMethods
	
	Table_name = "bos_#{BOS::Prop[:site_name]}_categories"
	Table_name_r = "bos_#{BOS::Prop[:site_name]}_category_r"
	
	def initialize(category_id)
		@mydb = BOS::MySQLo
		@mydo = BOS::Rdb
		@prop = set_default
		setup if BOS::Prop[:sitesetup] && !@mydb.list_tables.include?(Table_name)
		if !(category_id.is_a? Numeric) || !(category_id.integer?)
#			category_id = category_id.to_i == 0 ? get_id(category_id) : category_id.to_i
			category_id = category_id.to_i || 0
		end
		if category_id != 0
			load_id(category_id)
		end
	end
	
	def setup
		@mydb.query("CREATE TABLE #{Table_name}(" +
			"category_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"category_name TEXT," +
			"category_info TEXT," +
			"disp_flg VARCHAR(1) );")
			
		@mydb.query("CREATE TABLE #{Table_name_r}(" +
			"category_r_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"self_category_id INT," +
			"sub_category_id INT," +
			"sub_type VARCHAR(1)," +
			"disp_order INT," +
			"disp_type_order INT);")
	end
	
	def set_default
		{
			:category_id     => 0,
			:category_name   => "",
			:category_info   => "",
			:disp_flg        => 'p'}
	end
	
	def load_id(cid,sl=nil)
		return nil unless cid
		@prop = @mydo.exp({
			:command => "s",
			:target  => Table_name,
			:cols    => set_default,
			:where   => w("category_id"){|a| a == cid }})[0]
	end
	
  def cate_tree(cmod='p',cols=nil,cid=nil)
    cate_list(cid,cmod)
	end
	
	def cate_list(cmod='p',cols=nil,cid=nil)
	  cols ||= {:category_name => ""}
    cid ||= @prop[:category_id]
    tnr = Table_name_r
    case cmod
    when 'c'
      tn  = Table_name
      tid = 'category_id'
    when 'p'
      tn  = EsrProduct::Table_name
      tid = 'product_id'
    end
    
    @mydo.exp({
			:command => "s",
			:target  => rj(tnr,tn){|a,b| a['sub_category_id'] == b[tid] },
			:cols    => cols,
			:where   => w(tnr,tn){|a,b| (a['self_category_id'] == cid) & (a['sub_type'] == cmod) },
			:order   => 'disp_order'})
	end
	
	def add(peid,pemod='c',dispo=0,dispdot=0,cid=nil)
    cid ||= @prop[:category_id]
    del(peid,pemod,cid)
    @mydo.exp({
			:command => "i",
			:target  => Table_name_r,
			:cols    => {
  			:self_category_id => cid,
  			:sub_category_id => peid,
  			:sub_type => pemod,
  			:disp_order      => dispo,
  			:disp_type_order => dispdot }})
	end
	
	def del(peid,pemod='c',cid=nil)
    cid ||= @prop[:category_id]
    @mydo.exp({
			:command => "d",
			:target  => Table_name_r,
			:where   => w(Table_name_r){|a|
			  (a['self_category_id'] == cid) & (a['sub_category_id'] == peid) & (a['sub_type'] == pemod) }
		})
	end
	
	def get_list(pg=1, pc=10, sc="", sb=nil)
		pg = pg || 1
		pc = pc || 10
		@mydo.exp({
			:command => "s",
			:target  => Table_name,
			:cols    => set_default,
			:order   => sb ? "#{sb[:key]} #{sb[:mode]}" : "category_id ASC",
			:page    => pg,
			:pagesize => pc })
	end
	
	def commit
		if @prop[:category_id] == 0 then
			@prop.delete(:category_id)
			@prop[:category_id] = @mydo.exp({
				:command => "i",
				:target  => Table_name,
				:cols    => @prop })[:insid]
		else
			lct = @mydo.exp({
				:command => "u",
				:target  => Table_name,
				:cols    => @prop,
				:where   => w("category_id"){|a| a == @prop[:category_id]}})
		end

		@prop[:category_id]
	end

end
