# $Id: bos_comment.rb,v 1.1 2006/10/24 05:39:03 nisyu Exp $

class BosComment
  include BOS::PropMethods
  include BOS::SetupMethods
  
  Table_name = "bos_#{BOS::Prop[:site_name]}_pg_comments"
  
  def self.comments(prod_id=nil)
    BOS::Rdb.exp({
      :command => "s",
      :target  => Table_name,
      :cols    => {
        :comment_id => 0,
        :product_id => 0,
        :user_id => "",
        :h_name => "",
        :subject => "",
        :message => "",
        :url => "",
        :e_mail => "",
        :in_date => DateTime.now,
        :disp_flg => "" },
      :where   => w('product_id','disp_flg'){|a,b| (a == prod_id) & (b == 'p') } })
  end
  
  def initialize(comment_id)
  	setup
  	load_id(comment_id)
  end
  
  def setup_db
  	@mydb.query("CREATE TABLE #{Table_name}(" +
  		"comment_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
  		"product_id INT NOT NULL," +
  		"user_id VARCHAR(20) NOT NULL," +
  		"h_name VARCHAR(255) NOT NULL," +
  		"subject VARCHAR(255) NOT NULL," +
  		"message TEXT NOT NULL," +
  		"url VARCHAR(255) NOT NULL," +
  		"e_mail VARCHAR(255) NOT NULL," +
  		"in_date DATETIME," +
  		"disp_flg CHAR(1) NOT NULL);")
  end
  
  def set_default
    {
      :comment_id => 0,
      :product_id => 0,
      :user_id => "",
      :h_name => "",
      :subject => "",
      :message => "",
      :url => "",
      :e_mail => "",
      :in_date => DateTime.now,
      :disp_flg => 'p' }
  end

  def load_id(pid)
    return nil unless pid
    @prop = @mydo.exp({
      :command => "s",
      :target  => Table_name,
      :cols    => set_default,
      :where   => w('comment_id'){|a| a == pid } })[0]
    @prop = set_default unless @prop
  end
  
  def commit
    if @prop[:comment_id] == 0
      @prop.delete(:comment_id)
      @prop[:comment_id] = @mydo.exp({
        :command => "i",
        :target  => Table_name,
        :cols    => @prop })[:insid]
    else
      lct = @mydo.exp({
        :command => "u",
        :target  => Table_name,
        :cols    => @prop,
        :where   => "comment_id = #{@prop[:comment_id]}" })
    end
    
    @prop[:comment_id]
  end

end

class BosPagegen
  def add_comment(n,v)
    c = BosComment.new(0)
    c[:product_id] = @prop[:product_id]
    c[:h_name] = n
    c[:message] = v
    c.commit
  end
  def comments
    BosComment.new(0) # - create db ..orz
    BosComment::comments(@prop[:product_id])
  end
end
