# $Id: bos_trakback.rb,v 1.1 2006/10/24 05:39:03 nisyu Exp $

class BosTracBack
  include BOS::PropMethods
  include BOS::SetupMethods
  
  Table_name = "bos_#{BOS::Prop[:site_name]}_pg_tracback"
  
  def self.tracbacks(prod_id=nil)
    BOS::Rdb.exp({
      :command => "s",
      :target  => Table_name,
      :cols    => {
        :tracback_id => 0,
        :product_id => 0,
        :blog_name => "",
        :subject => "",
        :excerpt => "",
        :url => "",
        :in_date => DateTime.now,
        :disp_flg => 'p' },
      :where   => w('product_id','disp_flg'){|a,b| (a == prod_id) & (b == 'p') } })
  end
  
  def initialize(tracback_id)
  	setup
  	load_id(tracback_id)
  end
  
  def setup_db
  	@mydb.query("CREATE TABLE #{Table_name}(" +
      "tracback_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
      "product_id INT NOT NULL," +
      "blog_name VARCHAR(255) NOT NULL," +
      "subject VARCHAR(255) NOT NULL," +
      "excerpt TEXT NOT NULL," +
      "url VARCHAR(255) NOT NULL," +
      "in_date DATETIME," +
      "disp_flg CHAR(1) NOT NULL);")
  end
  
  def set_default
    {
      :tracback_id => 0,
      :product_id => 0,
      :blog_name => "",
      :subject => "",
      :excerpt => "",
      :url => "",
      :in_date => DateTime.now,
      :disp_flg => 'p' }
  end

  def load_id(pid)
    return nil unless pid
    @prop = @mydo.exp({
      :command => "s",
      :target  => Table_name,
      :cols    => set_default,
      :where   => w('tracback_id'){|a| a == pid } })[0]
    @prop = set_default unless @prop
  end
  
  def commit
    if @prop[:tracback_id] == 0
      @prop.delete(:tracback_id)
      @prop[:tracback_id] = @mydo.exp({
        :command => "i",
        :target  => Table_name,
        :cols    => @prop })[:insid]
    else
      lct = @mydo.exp({
        :command => "u",
        :target  => Table_name,
        :cols    => @prop,
        :where   => "tracback_id = #{@prop[:tracback_id]}" })
    end
    
    @prop[:tracback_id]
  end

end

class BosPagegen
  def add_tracback
    c = BosTracBack.new(0)
    c[:product_id] = @prop[:product_id]
    c.commit
  end
  def tracbacks
    BosTracBack.new(0) # - create db ..orz
    BosTracBack::tracbacks(@prop[:product_id])
  end
end

class BosTracBackSent
  include BOS::PropMethods
  include BOS::SetupMethods
  
  Table_name = "bos_#{BOS::Prop[:site_name]}_bos_tracback_sent"
  
  def initialize(tracback_id)
  	setup
  	load_id(tracback_id)
  end
  
  def setup_db
  	@mydb.query("CREATE TABLE #{Table_name}(" +
      "tracback_sent_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
      "product_id INT NOT NULL," +
      "tracback_text TEXT NOT NULL," +
      "status TEXT NOT NULL," +
      "sent_date DATETIME);")
  end
  
  def set_default
    {
      :tracback_sent_id => 0,
      :product_id => 0,
      :tracback_text => "",
      :status => "",
      :sent_date => DateTime.now }
  end

  def load_id(pid)
    return nil unless pid
    @prop = @mydo.exp({
      :command => "s",
      :target  => Table_name,
      :cols    => set_default,
      :where   => w('tracback_sent_id'){|a| a == pid } })[0]
    @prop = set_default unless @prop
  end
  
  def commit
    if @prop[:tracback_sent_id] == 0
      @prop.delete(:tracback_sent_id)
      @prop[:tracback_sent_id] = @mydo.exp({
        :command => "i",
        :target  => Table_name,
        :cols    => @prop })[:insid]
    else
      lct = @mydo.exp({
        :command => "u",
        :target  => Table_name,
        :cols    => @prop,
        :where   => "tracback_sent_id = #{@prop[:tracback_sent_id]}" })
    end
    
    @prop[:tracback_sent_id]
  end

end
